/*
Phi-1 shield for Arduino
Test program: car backing/reverse obstacle sensor with sonic ranger
This program is fairly long. For a nutshell version of this program to study with, visit http://liudr.wordpress.com/phi-1-shield/

Programmed by Dr. John Liu
Revision: 02/12/2011
Commerical use without authorization is prohibited.
Find details of the Phi-1 shield, Phi-2 shield or contact Dr. Liu at http://liudr.wordpress.com/phi-1-shield/
All rights reserved.
*/
void msg_lcd(char* msg_line)
{
  char msg_buffer[17];
  strcpy_P(msg_buffer,msg_line); 
  lcd.print(msg_buffer);
}

void render_menu(int me)
{
  char menu_buffer[20];
  lcd.clear();
  msg_lcd(msg_07);
  lcd.setCursor(0,1);
  strcpy_P(menu_buffer,(char*)pgm_read_word(&(menu_item[me]))); 
  lcd.print(menu_buffer);
}

void render_double_bar(int value, int max_v)
{
  char msg[7];
  int bar1, bar2, extra;
  byte i,j;
  long total_bar;
  total_bar=(20*((long)(value%max_v)))/((long)max_v);
  bar1=total_bar>=10?10:total_bar;
  bar2=total_bar>=10?(total_bar%10):0;
  extra=value/max_v;
  lcd.setCursor(0,0);
  for(i=0;i<bar1;i++)
  {
    lcd.write('\xff');
  }
  for(j=i;j<10;j++)
  {
    lcd.write(' ');
  }
//  lcd.print(bar1);
//  sprintf(msg,"%6d",extra);
//  lcd.print(msg);
  
  lcd.setCursor(0,1);
  for(i=0;i<bar2;i++)
  {
    lcd.write('\xff');
  }
  for(j=i;j<10;j++)
  {
    lcd.write(' ');
  }
//  lcd.print(bar2);
}

void do_menu()
{
  int temp1;
  temp1=hmi_with_update_2(menu_pointer,0,n_menu_items-1,1,16,1,0,render_menu); // Sticky menu item.
  menu_pointer=(temp1==-1)?menu_pointer:temp1; // In case escape was triggered, value doesn't change.
  switch (temp1)
  {
    case menu_display:
    _display();
    break;

    case menu_para:
    _parameters();
    break;
  }
}

void _display()
{
  while (!sonic_ranger(ch2))
  {}; // Keeps running sonic ranger until user presses a key to escape
}

void _parameters()
{
  int temp1, temp2;

  lcd.clear(); // Input on_divider
  lcd.print("On divider:");
  temp1=on_divider;
  temp2=hmi_with_update_3(&temp1, 10, 100, 1, 4, 1, 4, render_number_in_place); // Asks for period between recordings.
  on_divider=(temp2==-1)?on_divider:temp1; // In case escape was triggered, value doesn't change.

  delay(100);
  lcd.clear(); // Input off_divider
  lcd.print("Off divider:");
  temp1=off_divider;
  temp2=hmi_with_update_3(&temp1, 4, 50, 1, 4, 1, 4, render_number_in_place); // Asks for period between recordings.
  off_divider=(temp2==-1)?off_divider:temp1; // In case escape was triggered, value doesn't change.

  delay(100);
  lcd.clear(); // Input audio_alert
  lcd.print("Audio alert?");
  temp1=audio_alert;
  temp2=hmi_with_update_3(&temp1, 0, 1, 1, 1, 1, 3, render_YN_in_place); // Asks for period between recordings.
  audio_alert=(temp2==-1)?audio_alert:temp1; // In case escape was triggered, value doesn't change.
}
